; ================================================================================
; 								RallyeLect
; ================================================================================
;
; 	Par Cyrille Largillier en s'insiprant des scripts de fat115
; 	License : Ceccil
; 	Ce script permet de gnrer des fiches de rallye-lecture
; 	Compiler: AutoHotkey (http://www.autohotkey.com/).
;	Email : cyrille.largillier@free.Fr
;	Website : http://melospawn.free.fr
; ================================================================================

; On force le rpertoire des includes  tre celui du script
#Include %A_ScriptDir%
; On dsactive l'icne de la barre des tches
#NoTrayIcon
; On inclut pour le traitement des fichiers xml
#Include xpath.ahk
; Pour la suite, on dfinit de manire explicite le rpertoire de travail
SetWorkingDir %A_ScriptDir%
; On dfinit le format des Float
SetFormat, FloatFast, 0.2

; Traitement des PDF, chargement de la librairie HARU
#Include HPDF.ahk
hpdfDllFile := A_ScriptDir "\libhpdf.dll"
hDll := HPDF_LoadDLL(hpdfDllFile)

; On dfinit les sous dossiers pour le traitement des fichiers temporaires et des images
TempDir := A_ScriptDir . "\Temp"
ModeleDir := A_ScriptDir . "\Modele"
PDFDir := A_ScriptDir . "\PDF"
ProjetDir := A_ScriptDir . "\Projet"
IMConvert := A_ScriptDir . "\ImageMagick\convert.exe"
IMComposite := A_ScriptDir . "\ImageMagick\composite.exe"
PDFLecteur := A_ScriptDir . "\SumatraPDF\SumatraPDF.exe"

LogMsg := ""
NomFichier := ""
NomFichierCorrection := ""

; Lecture du fichier INI et construction des DropDownList
IniRead, FramaDevDir, %A_ScriptDir%\RallyeLect.ini, DEVELOPMENT, FramaKeyDir
IniRead, FramaEditor,  %A_ScriptDir%\RallyeLect.ini, DEVELOPMENT, FramaEditeur
IniRead, FramaCompiler,  %A_ScriptDir%\RallyeLect.ini, DEVELOPMENT, FramaCompilateur

ListLicense := ListIni("LICENSES")


; ================================================================================
;					 Dfinition de la GUI principale
; ================================================================================
MainGuiDef:
{
	; Dfinitions des Boutons & Onglets 
	Gui, Add, Text, x15 y4 w130 h16 , Version 0.7 - Janvier 2012
	Gui, Add, Button, x15 y20 w120 h30 vNouvelleFiche gNouvelleFiche, Nouvelle Fiche
	Gui, Add, Button, x15 y60 w120 h30 vOuvrirProjet gOuvrirProjet, Ouvrir un projet	
	Gui, Add, Button, x15 y100 w120 h30 vEnregistrerProjet gEnregistrerProjet, Enregistrer le projet
	Gui, Add, Button, x15 y140 w120 h30 vCreatePDF gCreatePDF, Crer le PDF de questions
	Gui, Add, Button, x15 y180 w120 h30 Disabled vReadPDF gReadPDF, Lire le PDF de questions
	Gui, Add, Button, x15 y220 w120 h30 vCreatePDFCorrection gCreatePDFCorrection, Crer le PDF de correction
	Gui, Add, Button, x15 y260 w120 h30 Disabled vReadPDFCorrection gReadPDFCorrection, Lire le PDF de correction
	Gui, Add, Button, x15 y300 w120 h30 vAide gAide, Aide
	Gui, Add, Button, x15 y340 w120 h30 vGuiClose gGuiClose, Quitter
	Gui, Add, Tab, x156 y2 w714 h380 vOnglets, Gnral|Question1|Question2|Question3|Question4|Question5|Question6|Question7|Question8|Question9|Question10
	; Onglet Gnral
	Gui, Tab, Gnral
	{
		Gui, Add, GroupBox, x166 y32 w698 h180 , Informations sur le livre
		Gui, Add, Text, x173 y55 w152 h16 , Titre du livre
		Gui, Add, Edit, x332 y52 w300 h22 vBookTitle, 
		Gui, Add, Text, x173 y85 w152 h16 , Nom de l'auteur
		Gui, Add, Edit, x332 y82 w150 h22 vBookAuteur, 
		Gui, Add, Text, x173 y115 w152 h16 , Nom de l'illustrateur (si diffrent)
		Gui, Add, Edit, x332 y112 w150 h22 vBookIllustrateur, 
		Gui, Add, Text, x173 y145 w152 h16 , Nom de l'diteur
		Gui, Add, Edit, x332 y142 w150 h22 vBookEditeur, 
		Gui, Add, Text, x173 y172 w152 h20 , Image de la couverture 
		Gui, Add, Edit, x332 y172 w150 h20 vScreenFile, 
		Gui, Add, Button, x496 y172 w30 h20 gFileSelectScreen, ...
		Gui, Add, Picture, x676 y58 w128 h-1 vScreen128,
		
		Gui, Add, GroupBox, x166 y222 w698 h150 , Informations sur la fiche et son rdacteur
		Gui, Add, Text, x173 y245 w152 h16 , Rdacteur de la fiche
		Gui, Add, Edit, x332 y242 w200 h22 vFicheRedacteur, 
		Gui, Add, Text, x173 y275 w152 h16 , Courriel du rdacteur
		Gui, Add, Edit, x332 y272 w200 h22 vFicheEmail, 
		Gui, Add, Text, x173 y305 w152 h16 , Numro de la fiche
		Gui, Add, Edit, x332 y302 w30 h22 vFicheNumero, 
		Gui, Add, Text, x173 y335 w152 h16 , Licence
		Gui, Add, DropDownList, x332 y332 w200 h22 R5 vFicheLicense, %ListLicense%
	}
	; Onglet Question1
	Gui, Tab, Question1
	{
		Gui, Add, Text, x173 y45 w70 h16 , Question 1
		Gui, Add, Edit, x243 y42 w600 h22 vQuestion_1,
		Gui, Add, Text, x173 y75 w70 h30 , Type de question
		Gui, Add, DropDownList, x243 y75 vChoixQuestion_1 gChoixQuestion_1, QCM|Ouverte
		Gui, Add, Text, x173 y110 w70 h30  Hidden vTexteOuverte_1, lments de rponse
		Gui, Add, Edit, x243 y107 w600 h50  Hidden vReponseOuverte_1, 
		Gui, Add, Text, x800 y90 w50 h16 Hidden vTexteExact_1, Exact
		Gui, Add, Text, x173 y110 w70 h16 Hidden vTexteReponseA_1, Rponse A
		Gui, Add, Edit, x243 y107 w450 h22 Hidden vReponseA_1, 
		Gui, Add, Checkbox, x810 y110 Hidden vExactA_1,
		Gui, Add, Text, x173 y150 w70 h16 Hidden vTexteReponseB_1, Rponse B
		Gui, Add, Edit, x243 y147 w450 h22 Hidden vReponseB_1, 
		Gui, Add, Checkbox, x810 y150 Hidden vExactB_1,
		Gui, Add, Text, x173 y190 w70 h16 Hidden vTexteReponseC_1, Rponse C
		Gui, Add, Edit, x243 y187 w450 h22 Hidden vReponseC_1, 
		Gui, Add, Checkbox, x810 y190 Hidden vExactC_1,
		Gui, Add, Text, x173 y230 w70 h16 Hidden vTexteReponseD_1, Rponse D
		Gui, Add, Edit, x243 y227 w450 h22 Hidden vReponseD_1, 
		Gui, Add, Checkbox, x810 y230 Hidden vExactD_1,
		Gui, Add, GroupBox, x166 y260 w698 h110 vContour_1 Hidden,
		Gui, Add, Text, x173 y300 w70 h16 Hidden vTexteDisposition_1, Disposition
		Gui, Add, Picture, x243 y275 w64 h-1 Hidden vImageA_1, %ModeleDir%\reponse1.png
		Gui, Add, Picture, x353 y275 w64 h-1 Hidden vImageB_1, %ModeleDir%\reponse2.png
		Gui, Add, Picture, x463 y275 w64 h-1 Hidden vImageC_1, %ModeleDir%\reponse3.png
		NbObjet_1=17
		Gui, Add, Radio,x271 y340 vDisposition_1 gDisposition1A,
		Gui, Add, Radio,x381 y340 gDisposition1B,
		Gui, Add, Radio,x491 y340 gDisposition1C,
		Gui, Add, Picture, x220 y250 w420 h-1 vImage_Cache_1, %ModeleDir%\cache_radio.png
		Gui, Add, Text, x700 y300 w120 h16 , Nombre de points
		Gui, Add, Edit, x800 y297 w30 h22 vNbPoints_1, 
	}
	; Onglet Question2
	Gui, Tab, Question2
	{
		Gui, Add, Text, x173 y45 w70 h16 , Question 2
		Gui, Add, Edit, x243 y42 w600 h22 vQuestion_2,
		Gui, Add, Text, x173 y75 w70 h30 , Type de question
		Gui, Add, DropDownList, x243 y75 vChoixQuestion_2 gChoixQuestion_2, QCM|Ouverte
		Gui, Add, Text, x173 y110 w70 h30 Hidden vTexteOuverte_2, lments de rponse
		Gui, Add, Edit, x243 y107 w600 h50 Hidden vReponseOuverte_2,
		Gui, Add, Text, x800 y90 w50 h16 Hidden vTexteExact_2, Exact
		Gui, Add, Text, x173 y110 w70 h16 Hidden vTexteReponseA_2, Rponse A
		Gui, Add, Edit, x243 y107 w450 h22 Hidden vReponseA_2, 
		Gui, Add, Checkbox, x810 y110 Hidden vExactA_2,
		Gui, Add, Text, x173 y150 w70 h16 Hidden vTexteReponseB_2, Rponse B
		Gui, Add, Edit, x243 y147 w450 h22 Hidden vReponseB_2, 
		Gui, Add, Checkbox, x810 y150 Hidden vExactB_2,
		Gui, Add, Text, x173 y190 w70 h16 Hidden vTexteReponseC_2, Rponse C
		Gui, Add, Edit, x243 y187 w450 h22 Hidden vReponseC_2, 
		Gui, Add, Checkbox, x810 y190 Hidden vExactC_2,
		Gui, Add, Text, x173 y230 w70 h16 Hidden vTexteReponseD_2, Rponse D
		Gui, Add, Edit, x243 y227 w450 h22 Hidden vReponseD_2, 
		Gui, Add, Checkbox, x810 y230 Hidden vExactD_2,
		Gui, Add, GroupBox, x166 y260 w698 h110 Hidden vContour_2,
		Gui, Add, Text, x173 y300 w70 h16 Hidden vTexteDisposition_2, Disposition
		Gui, Add, Picture, x243 y275 w64 h-1 Hidden vImageA_2, %ModeleDir%\reponse1.png
		Gui, Add, Picture, x353 y275 w64 h-1 Hidden vImageB_2, %ModeleDir%\reponse2.png
		Gui, Add, Picture, x463 y275 w64 h-1 Hidden vImageC_2, %ModeleDir%\reponse3.png
		NbObjet_2=25
		Gui, Add, Radio,x271 y340 vDisposition_2 gDisposition2A,
		Gui, Add, Radio,x381 y340 gDisposition2B,
		Gui, Add, Radio,x491 y340 gDisposition2C,
		Gui, Add, Picture, x220 y250 w420 h-1 vImage_Cache_2, %ModeleDir%\cache_radio.png
		Gui, Add, Text, x700 y300 w120 h16 , Nombre de points
		Gui, Add, Edit, x800 y297 w30 h22 vNbPoints_2, 
	}
	Gui, Tab, Question3
	{
		Gui, Add, Text, x173 y45 w70 h16 , Question 3
		Gui, Add, Edit, x243 y42 w600 h22 vQuestion_3,
		Gui, Add, Text, x173 y75 w70 h30 , Type de question
		Gui, Add, DropDownList, x243 y75 vChoixQuestion_3 gChoixQuestion_3, QCM|Ouverte
		Gui, Add, Text, x173 y110 w70 h30 Hidden vTexteOuverte_3, lments de rponse
		Gui, Add, Edit, x243 y107 w600 h50 Hidden vReponseOuverte_3,
		Gui, Add, Text, x800 y90 w50 h16 Hidden vTexteExact_3, Exact
		Gui, Add, Text, x173 y110 w70 h16 Hidden vTexteReponseA_3, Rponse A
		Gui, Add, Edit, x243 y107 w450 h22 Hidden vReponseA_3, 
		Gui, Add, Checkbox, x810 y110 Hidden vExactA_3,
		Gui, Add, Text, x173 y150 w70 h16 Hidden vTexteReponseB_3, Rponse B
		Gui, Add, Edit, x243 y147 w450 h22 Hidden vReponseB_3, 
		Gui, Add, Checkbox, x810 y150 Hidden vExactB_3,
		Gui, Add, Text, x173 y190 w70 h16 Hidden vTexteReponseC_3, Rponse C
		Gui, Add, Edit, x243 y187 w450 h22 Hidden vReponseC_3, 
		Gui, Add, Checkbox, x810 y190 Hidden vExactC_3,
		Gui, Add, Text, x173 y230 w70 h16 Hidden vTexteReponseD_3, Rponse D
		Gui, Add, Edit, x243 y227 w450 h22 Hidden vReponseD_3, 
		Gui, Add, Checkbox, x810 y230 Hidden vExactD_3,
		Gui, Add, GroupBox, x166 y260 w698 h110 Hidden vContour_3,
		Gui, Add, Text, x173 y300 w70 h16 Hidden vTexteDisposition_3, Disposition
		Gui, Add, Picture, x243 y275 w64 h-1 Hidden vImageA_3, %ModeleDir%\reponse1.png
		Gui, Add, Picture, x353 y275 w64 h-1 Hidden vImageB_3, %ModeleDir%\reponse2.png
		Gui, Add, Picture, x463 y275 w64 h-1 Hidden vImageC_3, %ModeleDir%\reponse3.png
		NbObjet_3=33
		Gui, Add, Radio,x271 y340 vDisposition_3 gDisposition3A,
		Gui, Add, Radio,x381 y340 gDisposition3B,
		Gui, Add, Radio,x491 y340 gDisposition3C,
		Gui, Add, Picture, x220 y250 w420 h-1 vImage_Cache_3, %ModeleDir%\cache_radio.png
		Gui, Add, Text, x700 y300 w120 h16 , Nombre de points
		Gui, Add, Edit, x800 y297 w30 h22 vNbPoints_3, 
	}
	Gui, Tab, Question4
	{
		Gui, Add, Text, x173 y45 w70 h16 , Question 4
		Gui, Add, Edit, x243 y42 w600 h22 vQuestion_4,
		Gui, Add, Text, x173 y75 w70 h30 , Type de question
		Gui, Add, DropDownList, x243 y75 vChoixQuestion_4 gChoixQuestion_4, QCM|Ouverte
		Gui, Add, Text, x173 y110 w70 h30 Hidden vTexteOuverte_4, lments de rponse
		Gui, Add, Edit, x243 y107 w600 h50 Hidden vReponseOuverte_4,
		Gui, Add, Text, x800 y90 w50 h16 Hidden vTexteExact_4, Exact
		Gui, Add, Text, x173 y110 w70 h16 Hidden vTexteReponseA_4, Rponse A
		Gui, Add, Edit, x243 y107 w450 h22 Hidden vReponseA_4, 
		Gui, Add, Checkbox, x810 y110 Hidden vExactA_4,
		Gui, Add, Text, x173 y150 w70 h16 Hidden vTexteReponseB_4, Rponse B
		Gui, Add, Edit, x243 y147 w450 h22 Hidden vReponseB_4, 
		Gui, Add, Checkbox, x810 y150 Hidden vExactB_4,
		Gui, Add, Text, x173 y190 w70 h16 Hidden vTexteReponseC_4, Rponse C
		Gui, Add, Edit, x243 y187 w450 h22 Hidden vReponseC_4, 
		Gui, Add, Checkbox, x810 y190 Hidden vExactC_4,
		Gui, Add, Text, x173 y230 w70 h16 Hidden vTexteReponseD_4, Rponse D
		Gui, Add, Edit, x243 y227 w450 h22 Hidden vReponseD_4, 
		Gui, Add, Checkbox, x810 y230 Hidden vExactD_4,
		Gui, Add, GroupBox, x166 y260 w698 h110 Hidden vContour_4,
		Gui, Add, Text, x173 y300 w70 h16 Hidden vTexteDisposition_4, Disposition
		Gui, Add, Picture, x243 y275 w64 h-1 Hidden vImageA_4, %ModeleDir%\reponse1.png
		Gui, Add, Picture, x353 y275 w64 h-1 Hidden vImageB_4, %ModeleDir%\reponse2.png
		Gui, Add, Picture, x463 y275 w64 h-1 Hidden vImageC_4, %ModeleDir%\reponse3.png
		NbObjet_4=41
		Gui, Add, Radio,x271 y340 vDisposition_4 gDisposition4A,
		Gui, Add, Radio,x381 y340 gDisposition4B,
		Gui, Add, Radio,x491 y340 gDisposition4C,
		Gui, Add, Picture, x220 y250 w420 h-1 vImage_Cache_4, %ModeleDir%\cache_radio.png
		Gui, Add, Text, x700 y300 w120 h16 , Nombre de points
		Gui, Add, Edit, x800 y297 w30 h22 vNbPoints_4, 
	}
	Gui, Tab, Question5
	{
		Gui, Add, Text, x173 y45 w70 h16 , Question 5
		Gui, Add, Edit, x243 y42 w600 h22 vQuestion_5,
		Gui, Add, Text, x173 y75 w70 h30 , Type de question
		Gui, Add, DropDownList, x243 y75 vChoixQuestion_5 gChoixQuestion_5, QCM|Ouverte
		Gui, Add, Text, x173 y110 w70 h30 Hidden vTexteOuverte_5, lments de rponse
		Gui, Add, Edit, x243 y107 w600 h50 Hidden vReponseOuverte_5,
		Gui, Add, Text, x800 y90 w50 h16 Hidden vTexteExact_5, Exact
		Gui, Add, Text, x173 y110 w70 h16 Hidden vTexteReponseA_5, Rponse A
		Gui, Add, Edit, x243 y107 w450 h22 Hidden vReponseA_5, 
		Gui, Add, Checkbox, x810 y110 Hidden vExactA_5,
		Gui, Add, Text, x173 y150 w70 h16 Hidden vTexteReponseB_5, Rponse B
		Gui, Add, Edit, x243 y147 w450 h22 Hidden vReponseB_5, 
		Gui, Add, Checkbox, x810 y150 Hidden vExactB_5,
		Gui, Add, Text, x173 y190 w70 h16 Hidden vTexteReponseC_5, Rponse C
		Gui, Add, Edit, x243 y187 w450 h22 Hidden vReponseC_5, 
		Gui, Add, Checkbox, x810 y190 Hidden vExactC_5,
		Gui, Add, Text, x173 y230 w70 h16 Hidden vTexteReponseD_5, Rponse D
		Gui, Add, Edit, x243 y227 w450 h22 Hidden vReponseD_5, 
		Gui, Add, Checkbox, x810 y230 Hidden vExactD_5,
		Gui, Add, GroupBox, x166 y260 w698 h110 Hidden vContour_5,
		Gui, Add, Text, x173 y300 w70 h16 Hidden vTexteDisposition_5, Disposition
		Gui, Add, Picture, x243 y275 w64 h-1 Hidden vImageA_5, %ModeleDir%\reponse1.png
		Gui, Add, Picture, x353 y275 w64 h-1 Hidden vImageB_5, %ModeleDir%\reponse2.png
		Gui, Add, Picture, x463 y275 w64 h-1 Hidden vImageC_5, %ModeleDir%\reponse3.png
		NbObjet_5=49
		Gui, Add, Radio,x271 y340 vDisposition_5 gDisposition5A,
		Gui, Add, Radio,x381 y340 gDisposition5B,
		Gui, Add, Radio,x491 y340 gDisposition5C,
		Gui, Add, Picture, x220 y250 w420 h-1 vImage_Cache_5, %ModeleDir%\cache_radio.png
		Gui, Add, Text, x700 y300 w120 h16 , Nombre de points
		Gui, Add, Edit, x800 y297 w30 h22 vNbPoints_5, 
	}
	Gui, Tab, Question6
	{
		Gui, Add, Text, x173 y45 w70 h16 , Question 6
		Gui, Add, Edit, x243 y42 w600 h22 vQuestion_6,
		Gui, Add, Text, x173 y75 w70 h30 , Type de question
		Gui, Add, DropDownList, x243 y75 vChoixQuestion_6 gChoixQuestion_6, QCM|Ouverte
		Gui, Add, Text, x173 y110 w70 h30 Hidden vTexteOuverte_6, lments de rponse
		Gui, Add, Edit, x243 y107 w600 h50 Hidden vReponseOuverte_6,
		Gui, Add, Text, x800 y90 w50 h16 Hidden vTexteExact_6, Exact
		Gui, Add, Text, x173 y110 w70 h16 Hidden vTexteReponseA_6, Rponse A
		Gui, Add, Edit, x243 y107 w450 h22 Hidden vReponseA_6, 
		Gui, Add, Checkbox, x810 y110 Hidden vExactA_6,
		Gui, Add, Text, x173 y150 w70 h16 Hidden vTexteReponseB_6, Rponse B
		Gui, Add, Edit, x243 y147 w450 h22 Hidden vReponseB_6, 
		Gui, Add, Checkbox, x810 y150 Hidden vExactB_6,
		Gui, Add, Text, x173 y190 w70 h16 Hidden vTexteReponseC_6, Rponse C
		Gui, Add, Edit, x243 y187 w450 h22 Hidden vReponseC_6, 
		Gui, Add, Checkbox, x810 y190 Hidden vExactC_6,
		Gui, Add, Text, x173 y230 w70 h16 Hidden vTexteReponseD_6, Rponse D
		Gui, Add, Edit, x243 y227 w450 h22 Hidden vReponseD_6, 
		Gui, Add, Checkbox, x810 y230 Hidden vExactD_6,
		Gui, Add, GroupBox, x166 y260 w698 h110 Hidden vContour_6,
		Gui, Add, Text, x173 y300 w70 h16 Hidden vTexteDisposition_6, Disposition
		Gui, Add, Picture, x243 y275 w64 h-1 Hidden vImageA_6, %ModeleDir%\reponse1.png
		Gui, Add, Picture, x353 y275 w64 h-1 Hidden vImageB_6, %ModeleDir%\reponse2.png
		Gui, Add, Picture, x463 y275 w64 h-1 Hidden vImageC_6, %ModeleDir%\reponse3.png
		NbObjet_6=57
		Gui, Add, Radio,x271 y340 vDisposition_6 gDisposition6A,
		Gui, Add, Radio,x381 y340 gDisposition6B,
		Gui, Add, Radio,x491 y340 gDisposition6C,
		Gui, Add, Picture, x220 y250 w420 h-1 vImage_Cache_6, %ModeleDir%\cache_radio.png
		Gui, Add, Text, x700 y300 w120 h16 , Nombre de points
		Gui, Add, Edit, x800 y297 w30 h22 vNbPoints_6, 
	}
	Gui, Tab, Question7
	{
		Gui, Add, Text, x173 y45 w70 h16 , Question 7
		Gui, Add, Edit, x243 y42 w600 h22 vQuestion_7,
		Gui, Add, Text, x173 y75 w70 h30 , Type de question
		Gui, Add, DropDownList, x243 y75 vChoixQuestion_7 gChoixQuestion_7, QCM|Ouverte
		Gui, Add, Text, x173 y110 w70 h30 Hidden vTexteOuverte_7, lments de rponse
		Gui, Add, Edit, x243 y107 w600 h50 Hidden vReponseOuverte_7,
		Gui, Add, Text, x800 y90 w50 h16 Hidden vTexteExact_7, Exact
		Gui, Add, Text, x173 y110 w70 h16 Hidden vTexteReponseA_7, Rponse A
		Gui, Add, Edit, x243 y107 w450 h22 Hidden vReponseA_7, 
		Gui, Add, Checkbox, x810 y110 Hidden vExactA_7,
		Gui, Add, Text, x173 y150 w70 h16 Hidden vTexteReponseB_7, Rponse B
		Gui, Add, Edit, x243 y147 w450 h22 Hidden vReponseB_7, 
		Gui, Add, Checkbox, x810 y150 Hidden vExactB_7,
		Gui, Add, Text, x173 y190 w70 h16 Hidden vTexteReponseC_7, Rponse C
		Gui, Add, Edit, x243 y187 w450 h22 Hidden vReponseC_7, 
		Gui, Add, Checkbox, x810 y190 Hidden vExactC_7,
		Gui, Add, Text, x173 y230 w70 h16 Hidden vTexteReponseD_7, Rponse D
		Gui, Add, Edit, x243 y227 w450 h22 Hidden vReponseD_7, 
		Gui, Add, Checkbox, x810 y230 Hidden vExactD_7,
		Gui, Add, GroupBox, x166 y260 w698 h110 Hidden vContour_7,
		Gui, Add, Text, x173 y300 w70 h16 Hidden vTexteDisposition_7, Disposition
		Gui, Add, Picture, x243 y275 w64 h-1 Hidden vImageA_7, %ModeleDir%\reponse1.png
		Gui, Add, Picture, x353 y275 w64 h-1 Hidden vImageB_7, %ModeleDir%\reponse2.png
		Gui, Add, Picture, x463 y275 w64 h-1 Hidden vImageC_7, %ModeleDir%\reponse3.png
		NbObjet_7=65
		Gui, Add, Radio,x271 y340 vDisposition_7 gDisposition7A,
		Gui, Add, Radio,x381 y340 gDisposition7B,
		Gui, Add, Radio,x491 y340 gDisposition7C,
		Gui, Add, Picture, x220 y250 w420 h-1 vImage_Cache_7, %ModeleDir%\cache_radio.png
		Gui, Add, Text, x700 y300 w120 h16 , Nombre de points
		Gui, Add, Edit, x800 y297 w30 h22 vNbPoints_7, 
	}
	Gui, Tab, Question8
	{
		Gui, Add, Text, x173 y45 w70 h16 , Question 8
		Gui, Add, Edit, x243 y42 w600 h22 vQuestion_8,
		Gui, Add, Text, x173 y75 w70 h30 , Type de question
		Gui, Add, DropDownList, x243 y75 vChoixQuestion_8 gChoixQuestion_8, QCM|Ouverte
		Gui, Add, Text, x173 y110 w70 h30 Hidden vTexteOuverte_8, lments de rponse
		Gui, Add, Edit, x243 y107 w600 h50 Hidden vReponseOuverte_8,
		Gui, Add, Text, x800 y90 w50 h16 Hidden vTexteExact_8, Exact
		Gui, Add, Text, x173 y110 w70 h16 Hidden vTexteReponseA_8, Rponse A
		Gui, Add, Edit, x243 y107 w450 h22 Hidden vReponseA_8, 
		Gui, Add, Checkbox, x810 y110 Hidden vExactA_8,
		Gui, Add, Text, x173 y150 w70 h16 Hidden vTexteReponseB_8, Rponse B
		Gui, Add, Edit, x243 y147 w450 h22 Hidden vReponseB_8, 
		Gui, Add, Checkbox, x810 y150 Hidden vExactB_8,
		Gui, Add, Text, x173 y190 w70 h16 Hidden vTexteReponseC_8, Rponse C
		Gui, Add, Edit, x243 y187 w450 h22 Hidden vReponseC_8, 
		Gui, Add, Checkbox, x810 y190 Hidden vExactC_8,
		Gui, Add, Text, x173 y230 w70 h16 Hidden vTexteReponseD_8, Rponse D
		Gui, Add, Edit, x243 y227 w450 h22 Hidden vReponseD_8, 
		Gui, Add, Checkbox, x810 y230 Hidden vExactD_8,
		Gui, Add, GroupBox, x166 y260 w698 h110 Hidden vContour_8,
		Gui, Add, Text, x173 y300 w70 h16 Hidden vTexteDisposition_8, Disposition
		Gui, Add, Picture, x243 y275 w64 h-1 Hidden vImageA_8, %ModeleDir%\reponse1.png
		Gui, Add, Picture, x353 y275 w64 h-1 Hidden vImageB_8, %ModeleDir%\reponse2.png
		Gui, Add, Picture, x463 y275 w64 h-1 Hidden vImageC_8, %ModeleDir%\reponse3.png
		NbObjet_8=73
		Gui, Add, Radio,x271 y340 vDisposition_8 gDisposition8A,
		Gui, Add, Radio,x381 y340 gDisposition8B,
		Gui, Add, Radio,x491 y340 gDisposition8C,
		Gui, Add, Picture, x220 y250 w420 h-1 vImage_Cache_8, %ModeleDir%\cache_radio.png
		Gui, Add, Text, x700 y300 w120 h16 , Nombre de points
		Gui, Add, Edit, x800 y297 w30 h22 vNbPoints_8, 
	}
	Gui, Tab, Question9
	{
		Gui, Add, Text, x173 y45 w70 h16 , Question 9
		Gui, Add, Edit, x243 y42 w600 h22 vQuestion_9,
		Gui, Add, Text, x173 y75 w70 h30 , Type de question
		Gui, Add, DropDownList, x243 y75 vChoixQuestion_9 gChoixQuestion_9, QCM|Ouverte
		Gui, Add, Text, x173 y110 w70 h30 Hidden vTexteOuverte_9, lments de rponse
		Gui, Add, Edit, x243 y107 w600 h50 Hidden vReponseOuverte_9,
		Gui, Add, Text, x800 y90 w50 h16 Hidden vTexteExact_9, Exact
		Gui, Add, Text, x173 y110 w70 h16 Hidden vTexteReponseA_9, Rponse A
		Gui, Add, Edit, x243 y107 w450 h22 Hidden vReponseA_9, 
		Gui, Add, Checkbox, x810 y110 Hidden vExactA_9,
		Gui, Add, Text, x173 y150 w70 h16 Hidden vTexteReponseB_9, Rponse B
		Gui, Add, Edit, x243 y147 w450 h22 Hidden vReponseB_9, 
		Gui, Add, Checkbox, x810 y150 Hidden vExactB_9,
		Gui, Add, Text, x173 y190 w70 h16 Hidden vTexteReponseC_9, Rponse C
		Gui, Add, Edit, x243 y187 w450 h22 Hidden vReponseC_9, 
		Gui, Add, Checkbox, x810 y190 Hidden vExactC_9,
		Gui, Add, Text, x173 y230 w70 h16 Hidden vTexteReponseD_9, Rponse D
		Gui, Add, Edit, x243 y227 w450 h22 Hidden vReponseD_9, 
		Gui, Add, Checkbox, x810 y230 Hidden vExactD_9,
		Gui, Add, GroupBox, x166 y260 w698 h110 Hidden vContour_9,
		Gui, Add, Text, x173 y300 w70 h16 Hidden vTexteDisposition_9, Disposition
		Gui, Add, Picture, x243 y275 w64 h-1 Hidden vImageA_9, %ModeleDir%\reponse1.png
		Gui, Add, Picture, x353 y275 w64 h-1 Hidden vImageB_9, %ModeleDir%\reponse2.png
		Gui, Add, Picture, x463 y275 w64 h-1 Hidden vImageC_9, %ModeleDir%\reponse3.png
		NbObjet_9=81
		Gui, Add, Radio,x271 y340 vDisposition_9 gDisposition9A,
		Gui, Add, Radio,x381 y340 gDisposition9B,
		Gui, Add, Radio,x491 y340 gDisposition9C,
		Gui, Add, Picture, x220 y250 w420 h-1 vImage_Cache_9, %ModeleDir%\cache_radio.png
		Gui, Add, Text, x700 y300 w120 h16 , Nombre de points
		Gui, Add, Edit, x800 y297 w30 h22 vNbPoints_9, 
	}
	Gui, Tab, Question10
	{
		Gui, Add, Text, x173 y45 w70 h16 , Question 10
		Gui, Add, Edit, x243 y42 w600 h22 vQuestion_10,
		Gui, Add, Text, x173 y75 w70 h30 , Type de question
		Gui, Add, DropDownList, x243 y75 vChoixQuestion_10 gChoixQuestion_10, QCM|Ouverte
		Gui, Add, Text, x173 y110 w70 h30 Hidden vTexteOuverte_10, lments de rponse
		Gui, Add, Edit, x243 y107 w600 h50 Hidden vReponseOuverte_10,		
		Gui, Add, Text, x800 y90 w50 h16 Hidden vTexteExact_10, Exact
		Gui, Add, Text, x173 y110 w70 h16 Hidden vTexteReponseA_10, Rponse A
		Gui, Add, Edit, x243 y107 w450 h22 Hidden vReponseA_10, 
		Gui, Add, Checkbox, x810 y110 Hidden vExactA_10,
		Gui, Add, Text, x173 y150 w70 h16 Hidden vTexteReponseB_10, Rponse B
		Gui, Add, Edit, x243 y147 w450 h22 Hidden vReponseB_10, 
		Gui, Add, Checkbox, x810 y150 Hidden vExactB_10,
		Gui, Add, Text, x173 y190 w70 h16 Hidden vTexteReponseC_10, Rponse C
		Gui, Add, Edit, x243 y187 w450 h22 Hidden vReponseC_10, 
		Gui, Add, Checkbox, x810 y190 Hidden vExactC_10,
		Gui, Add, Text, x173 y230 w70 h16 Hidden vTexteReponseD_10, Rponse D
		Gui, Add, Edit, x243 y227 w450 h22 Hidden vReponseD_10, 
		Gui, Add, Checkbox, x810 y230 Hidden vExactD_10,
		Gui, Add, GroupBox, x166 y260 w698 h110 Hidden vContour_10,
		Gui, Add, Text, x173 y300 w70 h16 Hidden vTexteDisposition_10, Disposition
		Gui, Add, Picture, x243 y275 w64 h-1 Hidden vImageA_10, %ModeleDir%\reponse1.png
		Gui, Add, Picture, x353 y275 w64 h-1 Hidden vImageB_10, %ModeleDir%\reponse2.png
		Gui, Add, Picture, x463 y275 w64 h-1 Hidden vImageC_10, %ModeleDir%\reponse3.png
		NbObjet_10=89
		Gui, Add, Radio,x271 y340 vDisposition_10 gDisposition10A,
		Gui, Add, Radio,x381 y340 gDisposition10B,
		Gui, Add, Radio,x491 y340 gDisposition10C,
		Gui, Add, Picture, x220 y250 w420 h-1 vImage_Cache_10, %ModeleDir%\cache_radio.png
		Gui, Add, Text, x700 y300 w120 h16 , Nombre de points
		Gui, Add, Edit, x800 y297 w30 h22 vNbPoints_10, 
	}
	Gui, Add, StatusBar, gLogWindow

	Gui, Show, Center h410 w876, RallyeLect
Return
}

; ================================================================================
;			Gestion des boites de dialogue de selection et de fermeture
; ================================================================================


FileSelectScreen:
{
	Gui +OwnDialogs  ; Force the user to dismiss the FileSelectFile dialog before returning to the main window.
	FileSelectFile,SelectedScreen,,,Slection de la couverture, Images (*.png; *.gif; *.jpg; *.jpeg; *.bmp)
	If ErrorLevel
		Return
	GuiControl,, ScreenFile, %SelectedScreen%
	ScreenshotFile := SelectedScreen
	Gosub, TransformScreen
Return
}

; ================================================================================
;						Gestion des boutons
; ================================================================================

;================================================================================================
;================================================================================================
; Bouton de choix entre QCM et Question ouverte
;================================================================================================
;================================================================================================

ChoixQuestion_1:
{
Affiche_Cache_Question(1)
}

ChoixQuestion_2:
{
Affiche_Cache_Question(2)
}

ChoixQuestion_3:
{
Affiche_Cache_Question(3)
}

ChoixQuestion_4:
{
Affiche_Cache_Question(4)
}

ChoixQuestion_5:
{
Affiche_Cache_Question(5)
}

ChoixQuestion_6:
{
Affiche_Cache_Question(6)
}

ChoixQuestion_7:
{
Affiche_Cache_Question(7)
}

ChoixQuestion_8:
{
Affiche_Cache_Question(8)
}

ChoixQuestion_9:
{
Affiche_Cache_Question(9)
}

ChoixQuestion_10:
{
Affiche_Cache_Question(10)
}

;================================================================================================
;================================================================================================
; Vrification que la longueur des chaines de caractres tapes dans les rponses corresponde
;  la disposition choisie.
;================================================================================================
;================================================================================================
Disposition1A:
{
VerifLongueurA(1)
Return
}

Disposition1B:
{
VerifLongueurB(1)
Return
}

Disposition1C:
{
VerifLongueurC(1)
Return
}

Disposition2A:
{
VerifLongueurA(2)
Return
}

Disposition2B:
{
VerifLongueurB(2)
Return
}

Disposition2C:
{
VerifLongueurC(2)
Return
}

Disposition3A:
{
VerifLongueurA(3)
Return
}

Disposition3B:
{
VerifLongueurB(3)
Return
}

Disposition3C:
{
VerifLongueurC(3)
Return
}

Disposition4A:
{
VerifLongueurA(4)
Return
}

Disposition4B:
{
VerifLongueurB(4)
Return
}

Disposition4C:
{
VerifLongueurC(4)
Return
}

Disposition5A:
{
VerifLongueurA(5)
Return
}

Disposition5B:
{
VerifLongueurB(5)
Return
}

Disposition5C:
{
VerifLongueurC(5)
Return
}

Disposition6A:
{
VerifLongueurA(6)
Return
}

Disposition6B:
{
VerifLongueurB(6)
Return
}

Disposition6C:
{
VerifLongueurC(6)
Return
}

Disposition7A:
{
VerifLongueurA(7)
Return
}

Disposition7B:
{
VerifLongueurB(7)
Return
}

Disposition7C:
{
VerifLongueurC(7)
Return
}

Disposition8A:
{
VerifLongueurA(8)
Return
}

Disposition8B:
{
VerifLongueurB(8)
Return
}

Disposition8C:
{
VerifLongueurC(8)
Return
}

Disposition9A:
{
VerifLongueurA(9)
Return
}

Disposition9B:
{
VerifLongueurB(9)
Return
}

Disposition9C:
{
VerifLongueurC(9)
Return
}

Disposition10A:
{
VerifLongueurA(10)
Return
}

Disposition10B:
{
VerifLongueurB(10)
Return
}

Disposition10C:
{
VerifLongueurC(10)
Return
}
;================================================================================================
;================================================================================================
; Nouvelle Fiche -> Efface toutes les donnes prcedemment entres et efface le contenu du dossier TMP
;================================================================================================
;================================================================================================
NouvelleFiche:
{
GuiControl, Disable, ReadPDF
GuiControl, Disable, ReadPDFCorrection
GuiControl,, BookTitle,
GuiControl,, BookAuteur,
GuiControl,, BookIllustrateur,
GuiControl,, BookEditeur,
GuiControl,, ScreenFile,
GuiControl,, FicheRedacteur,
GuiControl,, FicheEmail,
GuiControl,, FicheNumero,
GuiControl, ChooseString, FicheLicense, Creative Commons BY-SA
Loop, 10
	{
	GuiControl,, Question_%A_Index%,
	GuiControl,, ReponseA_%A_Index%,
	GuiControl,, ReponseB_%A_Index%,
	GuiControl,, ReponseC_%A_Index%,
	GuiControl,, ReponseD_%A_Index%,
	GuiControl,, ExactA_%A_Index%,0
	GuiControl,, ExactB_%A_Index%,0
	GuiControl,, ExactC_%A_Index%,0
	GuiControl,, ExactD_%A_Index%,0
	GuiControl,, Disposition_%A_Index%,0
	GuiControl,, NbPoints_%A_Index%,
	GuiControl, ChooseString , ChoixQuestion_%A_Index%, QCM
	GuiControl,, ReponseOuverte_%A_Index%,
	Affiche_Cache_Question(A_Index)
	}
GuiControl, , Screen128, 
Gosub CleanTemp
Return
}

;================================================================================================
;================================================================================================
; Ourvrir le projet
;================================================================================================
;================================================================================================
OuvrirProjet:
{
LogStatus("Dbut de l'ouverture d'un projet")
;on ouvre une boite de dialogue
Gui +OwnDialogs  ; Force the user to dismiss the FileSelectFile dialog before returning to the main window.
FileSelectFile,SelectedFileRallye,,%ProjetDir%,Slection d'un projet RallyeLect, Fichiers RallyeLect (*.rly)
If ErrorLevel
	Return

;dbut de lecture des donnes dans le fichier rly
IniRead, LivreTitre, %SelectedFileRallye%, General, Titre
IniRead, LivreAuteur, %SelectedFileRallye%, General, Auteur
IniRead, LivreIllustrateur, %SelectedFileRallye%, General, Illustrateur
IniRead, LivreEditeur, %SelectedFileRallye%, General, Editeur
IniRead, LivreImage, %SelectedFileRallye%, General, Image
IniRead, LivreRedacteur, %SelectedFileRallye%, General, Redacteur
IniRead, LivreEmail, %SelectedFileRallye%, General, Courriel
IniRead, LivreNumero, %SelectedFileRallye%, General, Numero
IniRead, LivreLicense, %SelectedFileRallye%, General, Licence
GuiControl,, BookTitle, %LivreTitre%
GuiControl,, BookAuteur, %LivreAuteur%
GuiControl,, BookIllustrateur, %LivreIllustrateur%
GuiControl,, BookEditeur, %LivreEditeur%
GuiControl,, ScreenFile, %LivreImage%
SelectedScreen := LivreImage
RunWait, "%IMConvert%" "%SelectedScreen%" -scale 650x750 -trim -background transparent -gravity center -extent 600x700 "%TempDir%\Cover.png",, Hide
RunWait, "%IMConvert%" "%SelectedScreen%" -scale 128x128 -trim -background transparent -gravity center -extent 128x128 "%TempDir%\Cover128.png",, Hide
GuiControl, , Screen128, %TempDir%\Cover128.png

GuiControl,, FicheRedacteur, %LivreRedacteur%
GuiControl,, FicheEmail, %LivreEmail%
GuiControl,, FicheNumero, %LivreNumero%
GuiControl, ChooseString, FicheLicense, %LivreLicense%
Loop, 10
{
	IniRead, ReadQuestion_%A_Index%, %SelectedFileRallye%, Question%A_Index%, Question
	IniRead, ReadChoixQuestion_%A_Index%, %SelectedFileRallye%, Question%A_Index%, ChoixQuestion
	IniRead, ReadReponseA_%A_Index%, %SelectedFileRallye%, Question%A_Index%, ReponseA
	IniRead, ReadReponseB_%A_Index%, %SelectedFileRallye%, Question%A_Index%, ReponseB
	IniRead, ReadReponseC_%A_Index%, %SelectedFileRallye%, Question%A_Index%, ReponseC
	IniRead, ReadReponseD_%A_Index%, %SelectedFileRallye%, Question%A_Index%, ReponseD
	IniRead, ReadExactA_%A_Index%, %SelectedFileRallye%, Question%A_Index%, ExactA
	IniRead, ReadExactB_%A_Index%, %SelectedFileRallye%, Question%A_Index%, ExactB
	IniRead, ReadExactC_%A_Index%, %SelectedFileRallye%, Question%A_Index%, ExactC
	IniRead, ReadExactD_%A_Index%, %SelectedFileRallye%, Question%A_Index%, ExactD
	IniRead, ReadDisposition_%A_Index%, %SelectedFileRallye%, Question%A_Index%, Disposition
	IniRead, ReadOuverte_%A_Index%, %SelectedFileRallye%, Question%A_Index%, Ouverte
	IniRead, ReadNbPoints_%A_Index%, %SelectedFileRallye%, Question%A_Index%, Points
	GuiControl,, Question_%A_Index%, % ReadQuestion_%A_Index%
	GuiControl, ChooseString, ChoixQuestion_%A_Index%, % ReadChoixQuestion_%A_Index%	
	GuiControl,, ReponseA_%A_Index%, % ReadReponseA_%A_Index%
	GuiControl,, ReponseB_%A_Index%, % ReadReponseB_%A_Index%
	GuiControl,, ReponseC_%A_Index%, % ReadReponseC_%A_Index%
	GuiControl,, ReponseD_%A_Index%, % ReadReponseD_%A_Index%
	GuiControl,, ExactA_%A_Index%, % ReadExactA_%A_Index%
	GuiControl,, ExactB_%A_Index%, % ReadExactB_%A_Index%
	GuiControl,, ExactC_%A_Index%, % ReadExactC_%A_Index%
	GuiControl,, ExactD_%A_Index%, % ReadExactD_%A_Index%
	RadioBtn := "Button" . (NbObjet_%A_Index% + ReadDisposition_%A_Index%)
	GuiControl,,%RadioBtn%,1
	GuiControl,, ReponseOuverte_%A_Index%, % ReadOuverte_%A_Index%
	GuiControl,, NbPoints_%A_Index%, % ReadNbPoints_%A_Index%
	Affiche_Cache_Question(A_Index)
}

LogStatus("Ouverture d'un projet termine")
return
}

;================================================================================================
;================================================================================================
; Enregistrer le projet
;================================================================================================
;================================================================================================
EnregistrerProjet:
{
Gui, Submit, NoHide
LogStatus("Dbut de l'enregistrement du projet")
;on copie le fichier modele dans le repertoire projet avec comme nom celui du titre du livre
NomFichierProjet= %BookTitle%
StringReplace, NomFichierProjet, NomFichierProjet, %A_SPACE%, _, All
StringReplace, NomFichierProjet, NomFichierProjet, ', _, All
StringReplace, NomFichierProjet, NomFichierProjet, `; , _, All
StringReplace, NomFichierProjet, NomFichierProjet, `, , _, All
StringReplace, NomFichierProjet, NomFichierProjet, `=, , _, All
StringReplace, NomFichierProjet, NomFichierProjet, `. , _, All
StringReplace, NomFichierProjet, NomFichierProjet, `! , _, All
StringReplace, NomFichierProjet, NomFichierProjet, `? , _, All
StringReplace, NomFichierProjet, NomFichierProjet, `: , _, All
StringReplace, NomFichierProjet, NomFichierProjet, `/ , _, All
StringReplace, NomFichierProjet, NomFichierProjet, `\ , _, All
StringReplace, NomFichierProjet, NomFichierProjet, `( , _, All
StringReplace, NomFichierProjet, NomFichierProjet, `) , _, All
StringReplace, NomFichierProjet, NomFichierProjet, `[ , _, All
StringReplace, NomFichierProjet, NomFichierProjet, `] , _, All
StringReplace, NomFichierProjet, NomFichierProjet, `{ , _, All
StringReplace, NomFichierProjet, NomFichierProjet, `} , _, All
StringReplace, NomFichierProjet, NomFichierProjet, `+ , _, All
StringReplace, NomFichierProjet, NomFichierProjet, `" , _, All

FileCopy, %ModeleDir%\modele.rly, %ProjetDir%\%NomFichierProjet%.rly

;dbut d'enregistrement des donnes dans le fichier rly
IniWrite, %BookTitle%, %ProjetDir%\%NomFichierProjet%.rly, General, Titre
IniWrite, %BookAuteur%, %ProjetDir%\%NomFichierProjet%.rly, General, Auteur
IniWrite, %BookIllustrateur%, %ProjetDir%\%NomFichierProjet%.rly, General, Illustrateur
IniWrite, %BookEditeur%, %ProjetDir%\%NomFichierProjet%.rly, General, Editeur
IniWrite, %ScreenFile%, %ProjetDir%\%NomFichierProjet%.rly, General, Image
IniWrite, %FicheRedacteur%, %ProjetDir%\%NomFichierProjet%.rly, General, Redacteur
IniWrite, %FicheEmail%, %ProjetDir%\%NomFichierProjet%.rly, General, Courriel
IniWrite, %FicheNumero%, %ProjetDir%\%NomFichierProjet%.rly, General, Numero
IniWrite, %FicheLicense%, %ProjetDir%\%NomFichierProjet%.rly, General, Licence

Loop, 10
{
if (Question_%A_Index% != "")
	{
	IniWrite, % Question_%A_Index%, %ProjetDir%\%NomFichierProjet%.rly, Question%A_Index%, Question
	IniWrite, % ChoixQuestion_%A_Index%, %ProjetDir%\%NomFichierProjet%.rly, Question%A_Index%, ChoixQuestion
	IniWrite, % ReponseA_%A_Index%, %ProjetDir%\%NomFichierProjet%.rly, Question%A_Index%, ReponseA
	IniWrite, % ReponseB_%A_Index%, %ProjetDir%\%NomFichierProjet%.rly, Question%A_Index%, ReponseB
	IniWrite, % ReponseC_%A_Index%, %ProjetDir%\%NomFichierProjet%.rly, Question%A_Index%, ReponseC
	IniWrite, % ReponseD_%A_Index%, %ProjetDir%\%NomFichierProjet%.rly, Question%A_Index%, ReponseD
	IniWrite, % ExactA_%A_Index%, %ProjetDir%\%NomFichierProjet%.rly, Question%A_Index%, ExactA
	IniWrite, % ExactB_%A_Index%, %ProjetDir%\%NomFichierProjet%.rly, Question%A_Index%, ExactB
	IniWrite, % ExactC_%A_Index%, %ProjetDir%\%NomFichierProjet%.rly, Question%A_Index%, ExactC
	IniWrite, % ExactD_%A_Index%, %ProjetDir%\%NomFichierProjet%.rly, Question%A_Index%, ExactD
	IniWrite, % Disposition_%A_Index%, %ProjetDir%\%NomFichierProjet%.rly, Question%A_Index%, Disposition
	IniWrite, % ReponseOuverte_%A_Index%, %ProjetDir%\%NomFichierProjet%.rly, Question%A_Index%, Ouverte
	IniWrite, % NbPoints_%A_Index%, %ProjetDir%\%NomFichierProjet%.rly, Question%A_Index%, Points
	
	}
}

LogStatus("Cration du fichier du projet termine")
Return
}

;================================================================================================
;================================================================================================
; Gnrer le PDF
;================================================================================================
;================================================================================================
CreatePDF:
{
Gui, Submit, NoHide

If (BookTitle = "")
		{
		MsgBox, 16, Oubli du titre, Il faut obligatoirement complter le titre du livre.
		Return
		}
		
LogStatus("Dbut de la cration du PDF de questions")

RunWait, "%IMComposite%" -geometry +1750+50 "%TempDir%\Cover.png" "%ModeleDir%\FicheVierge.png" "%TempDir%\fichecouv.png",,Hide

;Cration d'un nouveau document PDF en mmoire
hDoc := HPDF_New("error","000")

;Cration de la police par dfaut
font := HPDF_GetFont(hDoc, "Helvetica", "WinAnsiEncoding")

;Crtaion d'une page, A4, Portrait
page := HPDF_AddPage(hDoc)
HPDF_Page_SetSize(page, "A4", "PORTRAIT")

;Mode de compression du PDF
HPDF_SetCompressionMode(hDoc, "ALL")

;================================================================================================
; Ajout des informations sur le livre et le rdacteur sur le PDF
;================================================================================================
; Ajout de l'image de fond (structure + couverture)
if (ScreenFile <> "")
{
CheminImage = %TempDir%\fichecouv.png
}
Else
{
CheminImage = %ModeleDir%\FicheVierge.png
}
image := HPDF_LoadPngImageFromFile(hDoc, CheminImage)
HPDF_Page_DrawImage(page, image, 0, 0, HPDF_Page_GetWidth(page), HPDF_Page_GetHeight(page))

;print_grid(hDoc,page,10,2,2)

HPDF_Page_BeginText(page)

; Definition de l'paisseur de la ligne (du rectangle...)
;HPDF_Page_SetLineWidth(page, 1)

;Ecriture du titre
; Dfinition pour le texte  crire de la police et de  sa taille puis de sa position (2me ligne)
HPDF_Page_SetFontAndSize(page, font, 24)
HPDF_Page_MoveTextPos(page, 40, 705)

LargeurTitre := HPDF_Page_TextWidth(page, BookTitle) 
TaillePolice=24
while LargeurTitre > 370
    {
        TaillePolice := TaillePolice - 2
		HPDF_Page_SetFontAndSize(page, font, TaillePolice)
		LargeurTitre := HPDF_Page_TextWidth(page, BookTitle)
    }

; Ecriture du texte sur la page   
HPDF_Page_ShowText(page, BookTitle)

;Ecriture du nom de l'auteur, illustrateur et de l'diteur
; Dfinition pour le texte  crire de la police et de  sa taille puis de sa position (2me ligne)
HPDF_Page_SetFontAndSize(page, font, 11)
HPDF_Page_MoveTextPos(page, 0, -33)  
; Ecriture du texte sur la page 
TextAEcrire = %BookAuteur%
if (BookIllustrateur = "")
{
	if (BookEditeur <> "")
	{
	 TextAEcrire = %TextAEcrire% - Ed. %BookEditeur%
	}
}
Else
{
	if (BookEditeur <> "")
	{
	TextAEcrire = %TextAEcrire% et %BookIllustrateur% - Ed. %BookEditeur%
	}
	else
	{
	TextAEcrire = %TextAEcrire% et %BookIllustrateur%
	}
}
HPDF_Page_ShowText(page, TextAEcrire)

;Ajout Numro de fiche
HPDF_Page_SetFontAndSize(page, font, 20)
HPDF_Page_TextOut(page, 210, 810, FicheNumero)

;Ajout du nom - email du rdacteur et sa license
if (FicheRedacteur="")
{
	if (FicheEmail="")
	{
		TextAEcrire = Licence %FicheLicense%
	}
	Else
	{
		TextAEcrire = %FicheEmail% - Licence %FicheLicense%
	}
}
Else
{
	TextAEcrire = %FicheRedacteur%
	if (FicheEmail="")
	{
		TextAEcrire = %TextAEcrire% - Licence %FicheLicense%
	}
	Else
	{
		TextAEcrire = %TextAEcrire% - %FicheEmail% - Licence %FicheLicense%
	}
}
HPDF_Page_SetFontAndSize(page, font, 6)
angle1 := 90                   ; A rotation of 90 degrees.
rad1 := angle1 / 180 * 3.141592 ; Calcurate the radian value.
HPDF_Page_SetTextMatrix(page, cos(rad1), sin(rad1), -sin(rad1), cos(rad1), 20, 80)
HPDF_Page_ShowText(page, TextAEcrire)
HPDF_Page_EndText(page)
;================================================================================================
; Ajout des questions sur le PDF
;================================================================================================

nbQuestion := 0
PosX = 40
PosY = 640

Loop, 10
{
if (Question_%A_Index% != "")
	{
	HPDF_Page_SetRGBFill(page, 0.7, 0.7, 0.7)
	HPDF_Page_Rectangle(page, PosX-3, PosY-3, 16, 16)
	HPDF_Page_Fill(page)
	HPDF_Page_SetRGBFill(page, 0, 0, 0)
	
	HPDF_Page_BeginText(page)
	HPDF_Page_SetFontAndSize(page, font, 12)
	TextAEcrire = %A_Index%.
	HPDF_Page_TextOut(page, PosX, PosY, TextAEcrire)
	TextAEcrire =  % Question_%A_Index%
	HPDF_Page_TextOut(page, PosX+20, PosY, TextAEcrire)
	HPDF_Page_EndText(page)
	
	if (ChoixQuestion_%A_Index%="Ouverte")
		{
		PosY := PosY - 60
		HPDF_Page_SetLineWidth(page, 1)
		HPDF_Page_Rectangle(page, PosX, PosY, 500, 50)
		HPDF_Page_Stroke(page)	
		}
	
	Else if (ChoixQuestion_%A_Index%="QCM")
		{
		if (Disposition_%A_Index%=1)
			{
			if(ReponseA_%A_Index% != "")
				{
				PosY := PosY - 15
				;print the lines of the page.
				HPDF_Page_SetLineWidth(page, 1)
				HPDF_Page_Rectangle(page, PosX, PosY, 10, 10)
				HPDF_Page_Stroke(page)
				HPDF_Page_BeginText(page)
				TextAEcrire= % ReponseA_%A_Index%
				HPDF_Page_TextOut(page, PosX + 12, PosY, TextAEcrire)
				HPDF_Page_EndText(page)
				}
			if(ReponseB_%A_Index% != "")
				{
				PosY := PosY-12
				;print the lines of the page.
				HPDF_Page_SetLineWidth(page, 1)
				HPDF_Page_Rectangle(page, PosX, PosY, 10, 10)
				HPDF_Page_Stroke(page)			
				HPDF_Page_BeginText(page)
				TextAEcrire= % ReponseB_%A_Index%
				HPDF_Page_TextOut(page, PosX + 12, PosY, TextAEcrire)
				HPDF_Page_EndText(page)
				}
			if(ReponseC_%A_Index% != "")
				{
				PosY := PosY-12
				;print the lines of the page.
				HPDF_Page_SetLineWidth(page, 1)
				HPDF_Page_Rectangle(page, PosX, PosY, 10, 10)
				HPDF_Page_Stroke(page)		
				HPDF_Page_BeginText(page)
				TextAEcrire= % ReponseC_%A_Index%
				HPDF_Page_TextOut(page, PosX + 12, PosY, TextAEcrire)
				HPDF_Page_EndText(page)
				}
			if(ReponseD_%A_Index% != "")
				{
				PosY := PosY-12
				;print the lines of the page.
				HPDF_Page_SetLineWidth(page, 1)
				HPDF_Page_Rectangle(page, PosX, PosY, 10, 10)
				HPDF_Page_Stroke(page)			
				HPDF_Page_BeginText(page)
				TextAEcrire= % ReponseD_%A_Index%
				HPDF_Page_TextOut(page, PosX + 12, PosY, TextAEcrire)
				HPDF_Page_EndText(page)
				}
			}
	
		Else if (Disposition_%A_Index%=2)
			{
			if(ReponseA_%A_Index% != "")
				{
				PosY := PosY - 15
				;print the lines of the page.
				HPDF_Page_SetLineWidth(page, 1)
				HPDF_Page_Rectangle(page, PosX, PosY, 10, 10)
				HPDF_Page_Stroke(page)			
				HPDF_Page_BeginText(page)
				TextAEcrire= % ReponseA_%A_Index%
				HPDF_Page_TextOut(page, PosX+12, PosY, TextAEcrire)
				HPDF_Page_EndText(page)
				}
			if(ReponseB_%A_Index% != "")
				{
				PosY := PosY
				PosX := PosX + 280
				;print the lines of the page.
				HPDF_Page_SetLineWidth(page, 1)
				HPDF_Page_Rectangle(page, PosX, PosY, 10, 10)
				HPDF_Page_Stroke(page)			
				HPDF_Page_BeginText(page)
				TextAEcrire= % ReponseB_%A_Index%
				HPDF_Page_TextOut(page, PosX+12, PosY, TextAEcrire)
				HPDF_Page_EndText(page)
				}
			if(ReponseC_%A_Index% != "")
				{
				PosY := PosY-12
				PosX := PosX - 280
				;print the lines of the page.
				HPDF_Page_SetLineWidth(page, 1)
				HPDF_Page_Rectangle(page, PosX, PosY, 10, 10)
				HPDF_Page_Stroke(page)			
				HPDF_Page_BeginText(page)
				TextAEcrire= % ReponseC_%A_Index%
				HPDF_Page_TextOut(page, PosX+12, PosY, TextAEcrire)
				HPDF_Page_EndText(page)
				}
			if(ReponseD_%A_Index% != "")
				{
				PosY := PosY
				PosX := PosX + 280
				;print the lines of the page.
				HPDF_Page_SetLineWidth(page, 1)
				HPDF_Page_Rectangle(page, PosX, PosY, 10, 10)
				HPDF_Page_Stroke(page)			
				HPDF_Page_BeginText(page)
				TextAEcrire= % ReponseD_%A_Index%
				HPDF_Page_TextOut(page, PosX+12, PosY, TextAEcrire)
				HPDF_Page_EndText(page)
				}
			}
		Else if (Disposition_%A_Index%=3)
			{
			if(ReponseA_%A_Index% != "")
				{
				PosY := PosY - 15
				;print the lines of the page.
				HPDF_Page_SetLineWidth(page, 1)
				HPDF_Page_Rectangle(page, PosX, PosY, 10, 10)
				HPDF_Page_Stroke(page)			
				HPDF_Page_BeginText(page)
				TextAEcrire= % ReponseA_%A_Index%
				HPDF_Page_TextOut(page, PosX+12, PosY, TextAEcrire)
				HPDF_Page_EndText(page)
				}
			if(ReponseB_%A_Index% != "")
				{
				PosX := PosX + 140
				;print the lines of the page.
				HPDF_Page_SetLineWidth(page, 1)
				HPDF_Page_Rectangle(page, PosX, PosY, 10, 10)
				HPDF_Page_Stroke(page)			
				HPDF_Page_BeginText(page)
				TextAEcrire= % ReponseB_%A_Index%
				HPDF_Page_TextOut(page, PosX+12, PosY, TextAEcrire)
				HPDF_Page_EndText(page)
				}
			if(ReponseC_%A_Index% != "")
				{
				PosX := PosX + 140
				;print the lines of the page.
				HPDF_Page_SetLineWidth(page, 1)
				HPDF_Page_Rectangle(page, PosX, PosY, 10, 10)
				HPDF_Page_Stroke(page)			
				HPDF_Page_BeginText(page)
				TextAEcrire= % ReponseC_%A_Index%
				HPDF_Page_TextOut(page, PosX+12, PosY, TextAEcrire)
				HPDF_Page_EndText(page)
				}
			if(ReponseD_%A_Index% != "")
				{
				PosX := PosX + 140
				;print the lines of the page.
				HPDF_Page_SetLineWidth(page, 1)
				HPDF_Page_Rectangle(page, PosX, PosY, 10, 10)
				HPDF_Page_Stroke(page)			
				HPDF_Page_BeginText(page)
				TextAEcrire= % ReponseD_%A_Index%
				HPDF_Page_TextOut(page, PosX+12, PosY, TextAEcrire)
				HPDF_Page_EndText(page)
				}
			}
		Else
			{
			MsgBox Vous n'avez pas choisi la disposition des rponses de la question %A_Index%
			Return
			}
		}
	
	
	NbQuestion := NbQuestion + 1
	;incrmentaion de la position du curseur
	PosX = 40
	PosY := PosY - 22
	}
}


;================================================================================================
; Ajout du tableau de rponses
;================================================================================================
HPDF_Page_SetRGBFill(page, 0.7, 0.7, 0.7)
HPDF_Page_Rectangle(page, 250, 60, 330, 20)
HPDF_Page_Fill(page)
			
HPDF_Page_Rectangle(page, 510, 20, 20, 60)
HPDF_Page_Stroke(page)	
			
HPDF_Page_Rectangle(page, 470, 20, 20, 60)
HPDF_Page_Stroke(page)	
			
HPDF_Page_Rectangle(page, 430, 20, 20, 60)
HPDF_Page_Stroke(page)	
			
HPDF_Page_Rectangle(page, 410, 20, 20, 60)
HPDF_Page_Stroke(page)	
			
HPDF_Page_Rectangle(page, 370, 20, 20, 60)
HPDF_Page_Stroke(page)	
			
HPDF_Page_Rectangle(page, 330, 20, 20, 60)
HPDF_Page_Stroke(page)	

HPDF_Page_SetRGBFill(page, 0, 0, 0)			
HPDF_Page_SetLineWidth(page, 1)
HPDF_Page_Rectangle(page, 250, 20, 330, 60)
HPDF_Page_Stroke(page)		
			
HPDF_Page_MoveTo(page, 250, 40)
HPDF_Page_LineTo(page, 580, 40)
HPDF_Page_Stroke(page)
			
HPDF_Page_MoveTo(page, 250, 60)
HPDF_Page_LineTo(page, 580, 60)
HPDF_Page_Stroke(page)

HPDF_Page_SetFontAndSize(page, font, 9)
HPDF_Page_BeginText(page)
HPDF_Page_TextOut(page, 252, 66, "QUESTION")
HPDF_Page_TextOut(page, 252, 46, "NOTE OBTENUE")
HPDF_Page_TextOut(page, 252, 26, "NOTE MAXIMALE")
HPDF_Page_TextOut(page, 542, 66, "TOTAL")
HPDF_Page_EndText(page)

NbPointsTotal := 0
PosX=336
PosY=66
Loop, 10
{
	HPDF_Page_BeginText(page)
	TextAEcrire = %A_Index%
	HPDF_Page_TextOut(page, PosX, PosY, TextAEcrire)
	if (Question_%A_Index% != "")
		{
		if NbPoints_%A_Index% is not integer
			{
			MsgBox Vous n'avez pas choisi le nombre de points attribu  la question %A_Index%
			return
			}
		Else
			{
			TextAEcrire= % NbPoints_%A_Index%
			HPDF_Page_TextOut(page, PosX, PosY-40, TextAEcrire)
			NbPointsTotal := NbPointsTotal + NbPoints_%A_Index%
			}
		}
	Else
		{
		TextAEcrire = X
		HPDF_Page_TextOut(page, PosX, PosY-40, TextAEcrire)
		HPDF_Page_TextOut(page, PosX, PosY-20, TextAEcrire)
		}
	HPDF_Page_EndText(page)
	PosX := PosX + 20
}
HPDF_Page_BeginText(page)
TextAEcrire= %NbPointsTotal%
HPDF_Page_TextOut(page, 552, 26, TextAEcrire)
HPDF_Page_EndText(page)
;================================================================================================
;Enregistre le PDF cr
;================================================================================================

NomFichier= %BookTitle%
StringReplace, NomFichier, NomFichier, %A_SPACE%, _, All
StringReplace, NomFichier, NomFichier, ', _, All
StringReplace, NomFichier, NomFichier, `; , _, All
StringReplace, NomFichier, NomFichier, `, , _, All
StringReplace, NomFichier, NomFichier, `=, , _, All
StringReplace, NomFichier, NomFichier, `. , _, All
StringReplace, NomFichier, NomFichier, `! , _, All
StringReplace, NomFichier, NomFichier, `? , _, All
StringReplace, NomFichier, NomFichier, `: , _, All
StringReplace, NomFichier, NomFichier, `/ , _, All
StringReplace, NomFichier, NomFichier, `\ , _, All
StringReplace, NomFichier, NomFichier, `( , _, All
StringReplace, NomFichier, NomFichier, `) , _, All
StringReplace, NomFichier, NomFichier, `[ , _, All
StringReplace, NomFichier, NomFichier, `] , _, All
StringReplace, NomFichier, NomFichier, `{ , _, All
StringReplace, NomFichier, NomFichier, `} , _, All
StringReplace, NomFichier, NomFichier, `+ , _, All
StringReplace, NomFichier, NomFichier, `" , _, All
NomFichier= %PDFDir%\%NomFichier%.pdf


IfExist, %NomFichier%
	{
	MsgBox, 4, , Une fiche avec ce nom existe dj. Voulez-vous le remplacer ?
	IfMsgBox, No
		{
		StringReplace, NomFichier, NomFichier, .pdf , bis.pdf, All
		HPDF_SaveToFile(hDoc, NomFichier)
		}
	Else
		{
		HPDF_SaveToFile(hDoc, NomFichier)
		}
	}
Else
	{
	HPDF_SaveToFile(hDoc, NomFichier)
	}
	
; Informe l'utilisateur de la fin de cration du PDF
LogStatus("Cration du PDF de questions termine.")

; Rend cliquable le bouton "Lire le PDF"
GuiControl, Enable, ReadPDF
Return
}

;================================================================================================
;================================================================================================
;Lecture du PDF de questions en ouvrant SumatraPDF
;================================================================================================
;================================================================================================
ReadPDF:
{
RunWait, "%PDFLecteur%" "%NomFichier%"
Return
}


;================================================================================================
;================================================================================================
; Gnrer le PDF de correction
;================================================================================================
;================================================================================================
CreatePDFCorrection:
{
Gui, Submit, NoHide

If (BookTitle = "")
		{
		MsgBox, 16, Oubli du titre, Il faut obligatoirement complter le titre du livre.
		Return
		}
		
LogStatus("Dbut de la cration du PDF de correction")

RunWait, "%IMComposite%" -geometry +1750+50 "%TempDir%\Cover.png" "%ModeleDir%\FicheVierge.png" "%TempDir%\fichecouv.png",,Hide

; Ancien code
;RunWait, "%IMConvert%" -pointsize 24 label:%BookAuteur% "%TempDir%\truc.jpg",,Hide
;RunWait, "%IMComposite%" -geometry +500+500 "%TempDir%\truc.jpg" "%TempDir%\FicheCouv.jpg" "%TempDir%\FicheCouv.jpg",,Hide
;RunWait, "%IMConvert%" "%TempDir%\FicheCouv.jpg" "%PDFDir%\%BookTitle%.pdf",,Hide
; Fin ancien code

;Cration d'un nouveau document PDF en mmoire
hDoc := HPDF_New("error","000")

;Cration de la police par dfaut
font := HPDF_GetFont(hDoc, "Helvetica", "WinAnsiEncoding")

;Crtaion d'une page, A4, Portrait
page := HPDF_AddPage(hDoc)
HPDF_Page_SetSize(page, "A4", "PORTRAIT")

;Mode de compression du PDF
HPDF_SetCompressionMode(hDoc, "ALL")

;HPDF_GetEncoder(hDoc, "WinAnsiEncoding")
;================================================================================================
; Ajout des informations sur le livre et le rdacteur sur le PDF
;================================================================================================
; Ajout de l'image de fond (structure + couverture)
if (ScreenFile <> "")
{
CheminImage = %TempDir%\fichecouv.png
}
Else
{
CheminImage = %ModeleDir%\FicheVierge.png
}
image := HPDF_LoadPngImageFromFile(hDoc, CheminImage)
HPDF_Page_DrawImage(page, image, 0, 0, HPDF_Page_GetWidth(page), HPDF_Page_GetHeight(page))

;print_grid(hDoc,page,10,2,2)

HPDF_Page_BeginText(page)

; Definition de l'paisseur de la ligne (du rectangle...)
;HPDF_Page_SetLineWidth(page, 1)

;Ecriture du titre
; Dfinition pour le texte  crire de la police et de  sa taille puis de sa position (2me ligne)
HPDF_Page_SetFontAndSize(page, font, 24)
HPDF_Page_MoveTextPos(page, 40, 705)  

LargeurTitre := HPDF_Page_TextWidth(page, BookTitle) 
TaillePolice=24
while LargeurTitre > 370
    {
        TaillePolice := TaillePolice - 2
		HPDF_Page_SetFontAndSize(page, font, TaillePolice)
		LargeurTitre := HPDF_Page_TextWidth(page, BookTitle)
    }

; Ecriture du texte sur la page   
HPDF_Page_ShowText(page, BookTitle)

;Ecriture du nom de l'auteur, illustrateur et de l'diteur
; Dfinition pour le texte  crire de la police et de  sa taille puis de sa position (2me ligne)
HPDF_Page_SetFontAndSize(page, font, 11)
HPDF_Page_MoveTextPos(page, 0, -33)  
; Ecriture du texte sur la page 
TextAEcrire = %BookAuteur%
if (BookIllustrateur = "")
{
	if (BookEditeur <> "")
	{
	 TextAEcrire = %TextAEcrire% - Ed. %BookEditeur%
	}
}
Else
{
	if (BookEditeur <> "")
	{
	TextAEcrire = %TextAEcrire% et %BookIllustrateur% - Ed. %BookEditeur%
	}
	else
	{
	TextAEcrire = %TextAEcrire% et %BookIllustrateur%
	}
}
HPDF_Page_ShowText(page, TextAEcrire)

;Ajout Numro de fiche
HPDF_Page_SetFontAndSize(page, font, 20)
HPDF_Page_TextOut(page, 210, 810, FicheNumero)

;Ajout du nom - email du rdacteur et sa license
if (FicheRedacteur="")
{
	if (FicheEmail="")
	{
		TextAEcrire = Licence %FicheLicense%
	}
	Else
	{
		TextAEcrire = %FicheEmail% - Licence %FicheLicense%
	}
}
Else
{
	TextAEcrire = %FicheRedacteur%
	if (FicheEmail="")
	{
		TextAEcrire = %TextAEcrire% - Licence %FicheLicense%
	}
	Else
	{
		TextAEcrire = %TextAEcrire% - %FicheEmail% - Licence %FicheLicense%
	}
}
HPDF_Page_SetFontAndSize(page, font, 6)
angle1 := 90                   ; A rotation of 90 degrees.
rad1 := angle1 / 180 * 3.141592 ; Calcurate the radian value.
HPDF_Page_SetTextMatrix(page, cos(rad1), sin(rad1), -sin(rad1), cos(rad1), 20, 80)
HPDF_Page_ShowText(page, TextAEcrire)
HPDF_Page_EndText(page)
;================================================================================================
; Ajout des questions sur le PDF
;================================================================================================

nbQuestion := 0
PosX = 40
PosY = 640

Loop, 10
{
if (Question_%A_Index% != "")
	{
	HPDF_Page_SetRGBFill(page, 0.7, 0.7, 0.7)
	HPDF_Page_Rectangle(page, PosX-3, PosY-3, 16, 16)
	HPDF_Page_Fill(page)
	HPDF_Page_SetRGBFill(page, 0, 0, 0)
	
	HPDF_Page_BeginText(page)
	HPDF_Page_SetFontAndSize(page, font, 12)
	TextAEcrire = %A_Index%.
	HPDF_Page_TextOut(page, PosX, PosY, TextAEcrire)
	TextAEcrire =  % Question_%A_Index%
	HPDF_Page_TextOut(page, PosX+20, PosY, TextAEcrire)
	HPDF_Page_EndText(page)
	
	if (ChoixQuestion_%A_Index%="Ouverte")
		{
		PosY := PosY - 25
		HPDF_Page_SetRGBFill(page, 1, 0, 0)
		HPDF_Page_BeginText(page)
		LongueurReponseOuverte:=StrLen(ReponseOuverte_%A_Index%)
;MsgBox %LongueurQuestionD%
		if (LongueurReponseOuverte > 90)
			{
			;TexteADecouper = ReponseOuverte_%A_Index%
			StringLeft, TextAEcrire, ReponseOuverte_%A_Index%, 90
			HPDF_Page_TextOut(page, PosX + 12, PosY, TextAEcrire)
			PosY := PosY-12
			StringMid, TextAEcrire, ReponseOuverte_%A_Index%, 90, 90 
			HPDF_Page_TextOut(page, PosX + 12, PosY, TextAEcrire)
			
			if (LongueurReponseOuverte > 180)
				{
				PosY := PosY-12
				StringMid, TextAEcrire, ReponseOuverte_%A_Index%, 180, 90 
				HPDF_Page_TextOut(page, PosX + 12, PosY, TextAEcrire)
				
				if (LongueurReponseOuverte > 270)
					{
					PosY := PosY-12
					StringMid, TextAEcrire, ReponseOuverte_%A_Index%, 270, 90 
					HPDF_Page_TextOut(page, PosX + 12, PosY, TextAEcrire)
					
					if (LongueurReponseOuverte > 360)
						{
						MsgBox, 48, Problme de longueur , lments de rponse de la question %A_Index% trop longs (maximum 360 caractres)
						Return
						}
					PosY := PosY + 12
					}
				PosY := PosY + 12
				}
			PosY := PosY + 12
			}	
			
		else
			{
			TextAEcrire= % ReponseOuverte_%A_Index%
			HPDF_Page_TextOut(page, PosX + 12, PosY, TextAEcrire)
			}
		PosY := PosY - 35
		HPDF_Page_EndText(page)
				
		HPDF_Page_SetLineWidth(page, 1)
		if (LongueurReponseOuverte > 270)
			{
			PosY := PosY - 10
			HPDF_Page_Rectangle(page, PosX, PosY, 500, 60)
			}
		else
			HPDF_Page_Rectangle(page, PosX, PosY, 500, 50)
		HPDF_Page_Stroke(page)	
		}
	
	Else if (ChoixQuestion_%A_Index%="QCM")
		{
		if (Disposition_%A_Index%=1)
			{
			if(ReponseA_%A_Index% != "")
				{
				PosY := PosY - 15
				if(ExactA_%A_Index% = 1)
					HPDF_Page_SetRGBFill(page, 1, 0, 0)
				else
					HPDF_Page_SetRGBFill(page, 0, 0, 0)
				;print the lines of the page.
				HPDF_Page_SetLineWidth(page, 1)
				HPDF_Page_Rectangle(page, PosX, PosY, 10, 10)
				HPDF_Page_Stroke(page)
				HPDF_Page_BeginText(page)
				TextAEcrire= % ReponseA_%A_Index%
				HPDF_Page_TextOut(page, PosX + 12, PosY, TextAEcrire)
				HPDF_Page_EndText(page)
				}
			if(ReponseB_%A_Index% != "")
				{
				PosY := PosY-12
				if(ExactB_%A_Index% = 1)
					HPDF_Page_SetRGBFill(page, 1, 0, 0)
				else
					HPDF_Page_SetRGBFill(page, 0, 0, 0)
				;print the lines of the page.
				HPDF_Page_SetLineWidth(page, 1)
				HPDF_Page_Rectangle(page, PosX, PosY, 10, 10)
				HPDF_Page_Stroke(page)			
				HPDF_Page_BeginText(page)
				TextAEcrire= % ReponseB_%A_Index%
				HPDF_Page_TextOut(page, PosX + 12, PosY, TextAEcrire)
				HPDF_Page_EndText(page)
				}
			if(ReponseC_%A_Index% != "")
				{
				PosY := PosY-12
				if(ExactC_%A_Index% = 1)
					HPDF_Page_SetRGBFill(page, 1, 0, 0)
				else
					HPDF_Page_SetRGBFill(page, 0, 0, 0)
				;print the lines of the page.
				HPDF_Page_SetLineWidth(page, 1)
				HPDF_Page_Rectangle(page, PosX, PosY, 10, 10)
				HPDF_Page_Stroke(page)		
				HPDF_Page_BeginText(page)
				TextAEcrire= % ReponseC_%A_Index%
				HPDF_Page_TextOut(page, PosX + 12, PosY, TextAEcrire)
				HPDF_Page_EndText(page)
				}
			if(ReponseD_%A_Index% != "")
				{
				PosY := PosY-12
				if(ExactD_%A_Index% = 1)
					HPDF_Page_SetRGBFill(page, 1, 0, 0)
				else
					HPDF_Page_SetRGBFill(page, 0, 0, 0)
				;print the lines of the page.
				HPDF_Page_SetLineWidth(page, 1)
				HPDF_Page_Rectangle(page, PosX, PosY, 10, 10)
				HPDF_Page_Stroke(page)			
				HPDF_Page_BeginText(page)
				TextAEcrire= % ReponseD_%A_Index%
				HPDF_Page_TextOut(page, PosX + 12, PosY, TextAEcrire)
				HPDF_Page_EndText(page)
				}
			}
	
		Else if (Disposition_%A_Index%=2)
			{
			if(ReponseA_%A_Index% != "")
				{
				PosY := PosY - 15
				if(ExactA_%A_Index% = 1)
					HPDF_Page_SetRGBFill(page, 1, 0, 0)
				else
					HPDF_Page_SetRGBFill(page, 0, 0, 0)
				;print the lines of the page.
				HPDF_Page_SetLineWidth(page, 1)
				HPDF_Page_Rectangle(page, PosX, PosY, 10, 10)
				HPDF_Page_Stroke(page)			
				HPDF_Page_BeginText(page)
				TextAEcrire= % ReponseA_%A_Index%
				HPDF_Page_TextOut(page, PosX+12, PosY, TextAEcrire)
				HPDF_Page_EndText(page)
				}
			if(ReponseB_%A_Index% != "")
				{
				PosY := PosY
				PosX := PosX + 280
				if(ExactB_%A_Index% = 1)
					HPDF_Page_SetRGBFill(page, 1, 0, 0)
				else
					HPDF_Page_SetRGBFill(page, 0, 0, 0)
				;print the lines of the page.
				HPDF_Page_SetLineWidth(page, 1)
				HPDF_Page_Rectangle(page, PosX, PosY, 10, 10)
				HPDF_Page_Stroke(page)			
				HPDF_Page_BeginText(page)
				TextAEcrire= % ReponseB_%A_Index%
				HPDF_Page_TextOut(page, PosX+12, PosY, TextAEcrire)
				HPDF_Page_EndText(page)
				}
			if(ReponseC_%A_Index% != "")
				{
				PosY := PosY-12
				PosX := PosX - 280
				if(ExactC_%A_Index% = 1)
					HPDF_Page_SetRGBFill(page, 1, 0, 0)
				else
					HPDF_Page_SetRGBFill(page, 0, 0, 0)
				;print the lines of the page.
				HPDF_Page_SetLineWidth(page, 1)
				HPDF_Page_Rectangle(page, PosX, PosY, 10, 10)
				HPDF_Page_Stroke(page)			
				HPDF_Page_BeginText(page)
				TextAEcrire= % ReponseC_%A_Index%
				HPDF_Page_TextOut(page, PosX+12, PosY, TextAEcrire)
				HPDF_Page_EndText(page)
				}
			if(ReponseD_%A_Index% != "")
				{
				PosY := PosY
				PosX := PosX + 280
				if(ExactD_%A_Index% = 1)
					HPDF_Page_SetRGBFill(page, 1, 0, 0)
				else
					HPDF_Page_SetRGBFill(page, 0, 0, 0)
				;print the lines of the page.
				HPDF_Page_SetLineWidth(page, 1)
				HPDF_Page_Rectangle(page, PosX, PosY, 10, 10)
				HPDF_Page_Stroke(page)			
				HPDF_Page_BeginText(page)
				TextAEcrire= % ReponseD_%A_Index%
				HPDF_Page_TextOut(page, PosX+12, PosY, TextAEcrire)
				HPDF_Page_EndText(page)
				}
			}
		Else if (Disposition_%A_Index%=3)
			{
			if(ReponseA_%A_Index% != "")
				{
				PosY := PosY - 15
				if(ExactA_%A_Index% = 1)
					HPDF_Page_SetRGBFill(page, 1, 0, 0)
				else
					HPDF_Page_SetRGBFill(page, 0, 0, 0)
				;print the lines of the page.
				HPDF_Page_SetLineWidth(page, 1)
				HPDF_Page_Rectangle(page, PosX, PosY, 10, 10)
				HPDF_Page_Stroke(page)			
				HPDF_Page_BeginText(page)
				TextAEcrire= % ReponseA_%A_Index%
				HPDF_Page_TextOut(page, PosX+12, PosY, TextAEcrire)
				HPDF_Page_EndText(page)
				}
			if(ReponseB_%A_Index% != "")
				{
				PosX := PosX + 140
				if(ExactB_%A_Index% = 1)
					HPDF_Page_SetRGBFill(page, 1, 0, 0)
				else
					HPDF_Page_SetRGBFill(page, 0, 0, 0)
				;print the lines of the page.
				HPDF_Page_SetLineWidth(page, 1)
				HPDF_Page_Rectangle(page, PosX, PosY, 10, 10)
				HPDF_Page_Stroke(page)			
				HPDF_Page_BeginText(page)
				TextAEcrire= % ReponseB_%A_Index%
				HPDF_Page_TextOut(page, PosX+12, PosY, TextAEcrire)
				HPDF_Page_EndText(page)
				}
			if(ReponseC_%A_Index% != "")
				{
				PosX := PosX + 140
				if(ExactC_%A_Index% = 1)
					HPDF_Page_SetRGBFill(page, 1, 0, 0)
				else
					HPDF_Page_SetRGBFill(page, 0, 0, 0)
				;print the lines of the page.
				HPDF_Page_SetLineWidth(page, 1)
				HPDF_Page_Rectangle(page, PosX, PosY, 10, 10)
				HPDF_Page_Stroke(page)			
				HPDF_Page_BeginText(page)
				TextAEcrire= % ReponseC_%A_Index%
				HPDF_Page_TextOut(page, PosX+12, PosY, TextAEcrire)
				HPDF_Page_EndText(page)
				}
			if(ReponseD_%A_Index% != "")
				{
				PosX := PosX + 140
				if(ExactD_%A_Index% = 1)
					HPDF_Page_SetRGBFill(page, 1, 0, 0)
				else
					HPDF_Page_SetRGBFill(page, 0, 0, 0)
				;print the lines of the page.
				HPDF_Page_SetLineWidth(page, 1)
				HPDF_Page_Rectangle(page, PosX, PosY, 10, 10)
				HPDF_Page_Stroke(page)			
				HPDF_Page_BeginText(page)
				TextAEcrire= % ReponseD_%A_Index%
				HPDF_Page_TextOut(page, PosX+12, PosY, TextAEcrire)
				HPDF_Page_EndText(page)
				}
			}
		Else
			{
			MsgBox Vous n'avez pas choisi la disposition des rponses de la question %A_Index%
			Return
			}
		}
	
	
	NbQuestion := NbQuestion + 1
	HPDF_Page_SetRGBFill(page, 0, 0, 0)
	;incrmentaion de la position du curseur
	PosX = 40
	PosY := PosY - 22
	}
}


;================================================================================================
;Enregistre le PDF cr
;================================================================================================
NomFichierCorrection= %BookTitle%
StringReplace, NomFichierCorrection, NomFichierCorrection, %A_SPACE%, _, All
StringReplace, NomFichierCorrection, NomFichierCorrection, ', _, All
StringReplace, NomFichierCorrection, NomFichierCorrection, `; , _, All
StringReplace, NomFichierCorrection, NomFichierCorrection, `, , _, All
StringReplace, NomFichierCorrection, NomFichierCorrection, `=, , _, All
StringReplace, NomFichierCorrection, NomFichierCorrection, `. , _, All
StringReplace, NomFichierCorrection, NomFichierCorrection, `! , _, All
StringReplace, NomFichierCorrection, NomFichierCorrection, `? , _, All
StringReplace, NomFichierCorrection, NomFichierCorrection, `: , _, All
StringReplace, NomFichierCorrection, NomFichierCorrection, `/ , _, All
StringReplace, NomFichierCorrection, NomFichierCorrection, `\ , _, All
StringReplace, NomFichierCorrection, NomFichierCorrection, `( , _, All
StringReplace, NomFichierCorrection, NomFichierCorrection, `) , _, All
StringReplace, NomFichierCorrection, NomFichierCorrection, `[ , _, All
StringReplace, NomFichierCorrection, NomFichierCorrection, `] , _, All
StringReplace, NomFichierCorrection, NomFichierCorrection, `{ , _, All
StringReplace, NomFichierCorrection, NomFichierCorrection, `} , _, All
StringReplace, NomFichierCorrection, NomFichierCorrection, `+ , _, All
StringReplace, NomFichierCorrection, NomFichierCorrection, `" , _, All
NomFichierCorrection= %PDFDir%\%NomFichierCorrection%Correction.pdf

IfExist, %NomFichierCorrection%
	{
	MsgBox, 4, , Une fiche avec ce nom existe dj. Voulez-vous le remplacer ?
	IfMsgBox, No
		{
		StringReplace, NomFichierCorrection, NomFichierCorrection, .pdf , bis.pdf, All
		HPDF_SaveToFile(hDoc, NomFichierCorrection)
		}
	Else
		{
		HPDF_SaveToFile(hDoc, NomFichierCorrection)
		}
	}
Else
	{
	HPDF_SaveToFile(hDoc, NomFichierCorrection)
	}

; Informe l'utilisateur de la fin de cration du PDF
LogStatus("Cration du PDF de correction termine.")

; Rend cliquable le bouton "Lire le PDF"
GuiControl, Enable, ReadPDFCorrection
Return
}


;================================================================================================
;================================================================================================
;Lecture du PDF de correction en ouvrant SumatraPDF
;================================================================================================
;================================================================================================
ReadPDFCorrection:
{
RunWait, "%PDFLecteur%" "%NomFichierCorrection%"
Return
}

;================================================================================================
;================================================================================================
; Aide - Ouvre un PDF contenant l'aide
;================================================================================================
;================================================================================================
Aide:
{
FichierAide := A_ScriptDir . "\aide.pdf"
RunWait, "%PDFLecteur%" "%FichierAide%"
Return
}

;================================================================================================
;================================================================================================
; Gestion du bouton Quitter
;================================================================================================
;================================================================================================
GuiClose:
	;unload dll
	HPDF_UnloadDLL(hDll)
	Gosub CleanTemp
	ExitApp
Return



CleanTemp:
{
	FileRemoveDir, %TempDir%, 1
	FileCreateDir, %TempDir%
Return
}

; ================================================================================
;						Gestion des contenus des contrles
; ================================================================================
; cration des captures cran
TransformScreen:
{
	SB_SetIcon("user32.dll", 5)
	LogStatus("Dbut de l'importation de la couverture")
	GuiControl, Disable, CreatePDF
	GuiControl, Disable, CreatePDFCorrection
	RunWait, "%IMConvert%" "%SelectedScreen%" -scale 650x750 -trim -background transparent -gravity center -extent 600x700 "%TempDir%\Cover.png",, Hide
	RunWait, "%IMConvert%" "%SelectedScreen%" -scale 128x128 -trim -background transparent -gravity center -extent 128x128 "%TempDir%\Cover128.png",, Hide
	LogStatus("Mise  l'chelle de la couverture termine.")
	GuiControl, , Screen128, %TempDir%\Cover128.png
	GuiControl, Enable, CreatePDF
	GuiControl, Enable, CreatePDFCorrection
Return
}

; ================================================================================
; 						Dfinitions des fonctions
; ================================================================================
VerifLongueurA(NoQuestion)
{
Gui, Submit, NoHide
Message = 
LongueurQuestionA:=StrLen(ReponseA_%NoQuestion%)
;MsgBox %LongueurQuestionA%
LongueurQuestionB:=StrLen(ReponseB_%NoQuestion%)
;MsgBox %LongueurQuestionB%
LongueurQuestionC:=StrLen(ReponseC_%NoQuestion%)
;MsgBox %LongueurQuestionC%
LongueurQuestionD:=StrLen(ReponseD_%NoQuestion%)
;MsgBox %LongueurQuestionD%
if ((LongueurQuestionA > 66) OR (LongueurQuestionB > 66) OR (LongueurQuestionC > 66) OR (LongueurQuestionD > 66))
	{
	Message = Rponse(s) trop longue(s) pour la disposition choisie : 
	if (LongueurQuestionA > 66)
		{
		Message = %Message% A 
		}
	if (LongueurQuestionB > 66)
		{
		Message = %Message% B 
		}
	if (LongueurQuestionC > 66)
		{
		Message = %Message% C 
		}
	if (LongueurQuestionD > 66)
		{
		Message = %Message% D 
		}
	MsgBox, 48, Problme de longueur , %Message%	
	Message = 
	}
Else 
	{
	return
	}
Return
}

VerifLongueurB(NoQuestion)
{
Gui, Submit, NoHide
Message = 
LongueurQuestionA:=StrLen(ReponseA_%NoQuestion%)
;MsgBox %LongueurQuestionA%
LongueurQuestionB:=StrLen(ReponseB_%NoQuestion%)
;MsgBox %LongueurQuestionB%
LongueurQuestionC:=StrLen(ReponseC_%NoQuestion%)
;MsgBox %LongueurQuestionC%
LongueurQuestionD:=StrLen(ReponseD_%NoQuestion%)
;MsgBox %LongueurQuestionD%
if ((LongueurQuestionA > 30) OR (LongueurQuestionB > 30) OR (LongueurQuestionC > 30) OR (LongueurQuestionD > 30))
	{
	Message = Rponse(s) trop longue(s) pour la disposition choisie : 
	if (LongueurQuestionA > 30)
		{
		Message = %Message% A 
		}
	if (LongueurQuestionB > 30)
		{
		Message = %Message% B 
		}
	if (LongueurQuestionC > 30)
		{
		Message = %Message% C 
		}
	if (LongueurQuestionD > 30)
		{
		Message = %Message% D 
		}
	MsgBox, 48, Problme de longueur , %Message%	
	Message = 
	}
Else 
	{
	return
	}
Return
}


VerifLongueurC(NoQuestion)
{
Gui, Submit, NoHide
Message = 
LongueurQuestionA:=StrLen(ReponseA_%NoQuestion%)
;MsgBox %LongueurQuestionA%
LongueurQuestionB:=StrLen(ReponseB_%NoQuestion%)
;MsgBox %LongueurQuestionB%
LongueurQuestionC:=StrLen(ReponseC_%NoQuestion%)
;MsgBox %LongueurQuestionC%
LongueurQuestionD:=StrLen(ReponseD_%NoQuestion%)
;MsgBox %LongueurQuestionD%
if ((LongueurQuestionA > 15) OR (LongueurQuestionB > 15) OR (LongueurQuestionC > 15) OR (LongueurQuestionD > 15))
	{
	Message = Rponse(s) trop longue(s) pour la disposition choisie : 
	if (LongueurQuestionA > 15)
		{
		Message = %Message% A 
		}
	if (LongueurQuestionB > 15)
		{
		Message = %Message% B 
		}
	if (LongueurQuestionC > 15)
		{
		Message = %Message% C 
		}
	if (LongueurQuestionD > 15)
		{
		Message = %Message% D 
		}
	MsgBox, 48, Problme de longueur , %Message%	
	Message = 
	}
Else 
	{
	return
	}
Return
}

Affiche_Cache_Question(NoQuestion)
{
Gui, Submit, NoHide

if (ChoixQuestion_%NoQuestion%="Ouverte")
	{
	GuiControl, Hide, TexteExact_%NoQuestion%
	GuiControl, Hide, TexteReponseA_%NoQuestion%
	GuiControl, Hide, ReponseA_%NoQuestion%
	GuiControl, Hide, ExactA_%NoQuestion%
	GuiControl, Hide, TexteReponseB_%NoQuestion%
	GuiControl, Hide, ReponseB_%NoQuestion%
	GuiControl, Hide, ExactB_%NoQuestion%
	GuiControl, Hide, TexteReponseC_%NoQuestion%
	GuiControl, Hide, ReponseC_%NoQuestion%
	GuiControl, Hide, ExactC_%NoQuestion%
	GuiControl, Hide, TexteReponseD_%NoQuestion%
	GuiControl, Hide, ReponseD_%NoQuestion%
	GuiControl, Hide, ExactD_%NoQuestion%
	GuiControl, Hide, Contour_%NoQuestion%
	GuiControl, Hide, TexteDisposition_%NoQuestion%
	GuiControl, Hide, ImageA_%NoQuestion%
	GuiControl, Hide, ImageB_%NoQuestion%
	GuiControl, Hide, ImageC_%NoQuestion%
	GuiControl, Show, Image_Cache_%NoQuestion%
	GuiControl, Show, TexteOuverte_%NoQuestion%
	GuiControl, Show, ReponseOuverte_%NoQuestion%
	}

Else
	{
	GuiControl, Hide, TexteOuverte_%NoQuestion%
	GuiControl, Hide, ReponseOuverte_%NoQuestion%
	GuiControl, Show, TexteExact_%NoQuestion%
	GuiControl, Show, TexteReponseA_%NoQuestion%
	GuiControl, Show, ReponseA_%NoQuestion%
	GuiControl, Show, ExactA_%NoQuestion%
	GuiControl, Show, TexteReponseB_%NoQuestion%
	GuiControl, Show, ReponseB_%NoQuestion%
	GuiControl, Show, ExactB_%NoQuestion%
	GuiControl, Show, TexteReponseC_%NoQuestion%
	GuiControl, Show, ReponseC_%NoQuestion%
	GuiControl, Show, ExactC_%NoQuestion%
	GuiControl, Show, TexteReponseD_%NoQuestion%
	GuiControl, Show, ReponseD_%NoQuestion%
	GuiControl, Show, ExactD_%NoQuestion%
	GuiControl, Show, Contour_%NoQuestion%
	GuiControl, Show, TexteDisposition_%NoQuestion%
	GuiControl, Show, ImageA_%NoQuestion%
	GuiControl, Show, ImageB_%NoQuestion%
	GuiControl, Show, ImageC_%NoQuestion%
	GuiControl, Hide, Image_Cache_%NoQuestion%

	}

}


ListIni(INISect)
{
	TempList := ""
	Loop {
		IniRead, Entry%A_Index%, %A_ScriptDir%\RallyeLect.ini, %INISect%, name%A_Index%, Fini
		IfEqual, Entry%A_Index%, Fini, Break
		TempList .= Entry%A_Index% . "|"
		}
	StringTrimRight, TempList, TempList, 1
Return, %TempList%
}

TestPicture(PicFolder, LocalPic, RemotePic)
{
	Ajout := ""
	IfNotExist, %PicFolder%\%LocalPic%
		{
		Ajout .= LocalPic
		IfNotEqual, RemotePic
			Ajout .= "* `r`n"
		Else
			Ajout .= "`r`n"
		}
Return %Ajout%
}

LogStatus(LogMessage)
{
	global LogMsg, LogDisplay
	LogMsg .= LogMessage . "|"
	SB_SetText(LogMessage)
	GuiControl, 3: , LogDisplay, %LogMessage%||
Return
}



; ================================================================================
;					 Gestion des Fentres supplmentaires
; ================================================================================

LogWindow:
{
	Gui, 3:+owner1 -SysMenu
	Gui, 3:Add, ListBox, x5 y5 w490 h300 ReadOnly vLogDisplay, %LogMsg%
	Gui, 3:Add, Button, x245 y310 w80 h25 gLogClose, Quitter
	Gui, 3:Show, Center h340 w500, Fentre de Log
Return
}

LogClose:
	Gui, 1:-Disabled
	Gui, Destroy
Return
